#ifndef TODOCLASSES_H
#define TODOCLASSES_H

#include "GameState.h"
#include "Windows.h"
#include "LargeInt.h"
#include "Perception.h"
#include "TextMessageBuffer.h"
#include "GameCommand.h"

typedef int Bool;

#define SP_SEND_STEP              150
#define TIME_TO_DELIBERATE         80
#define TIME_TO_SEND               50
/*
class CPerception
{
private:
    int m_nReceiveSystemTime;

private:
    int m_nPlayTime;
    //...

private:
    CGameTime m_tGameTime;
    EPlayMode m_mPlayMode;

public:
    CPerception() { m_mPlayMode = PM_NONE; };

    int GetPlayTime() { return m_nPlayTime; };
    void SetPlayTime(int nPlayTime) { m_nPlayTime = nPlayTime; };
    EPlayMode GetPlayMode() { return m_mPlayMode; };
    void SetPlayMode(EPlayMode mPlayMode) { m_mPlayMode = mPlayMode; };

    void SetGameTime(CGameTime m_tGameTime) { m_tGameTime = m_tGameTime; };
    int GetReceiveSystemTime() { return m_nReceiveSystemTime; };
    void SetReceiveSystemTime(int nReceiveTime) { m_nReceiveSystemTime = nReceiveTime; };
};

class CPerceptionSeq
{
public:
    CPerceptionSeq() {};

    CPerceptionSeq *AddPerception(CPerception *pPerception) { return NULL; };
};
*/

// class Player??? {
//     Deliberate(CPerceptionSeq *pPerceptionSeq, CCommandSeq *pDoneCommandSeq??, CCommandSeq *pToDoCommandSeq??);
// }

class CSystemClock
{
private:
    __int64 m_nInitCount;
    __int64 m_nCountsPerSec;

public:
    void Initialize() {
        LARGE_INTEGER nInitCount;
        LARGE_INTEGER nCountsPerSec;

        QueryPerformanceFrequency(&nCountsPerSec);  m_nCountsPerSec = nCountsPerSec.QuadPart;
        QueryPerformanceCounter(&nInitCount);  m_nInitCount = nInitCount.QuadPart;
        //if (QueryPerformanceCounter(&m_nInitCount) == FALSE);
            // exception;
    };
    int GetTime() {
        LARGE_INTEGER nCurCount;

        QueryPerformanceCounter(&nCurCount);
        //if (QueryPerformanceCounter(&nCurCount) == FALSE);
            // exception;

        return int(((__int64(nCurCount.QuadPart) - m_nInitCount) * 1000) / m_nCountsPerSec);
//        nResCount = LargeIntegerDivide(ExtendedIntegerMultiply(LargeIntegerSubtract(nCurCount, m_nInitCount),1000), m_nCountsPerSec, &nRemainder);
//        nResCount = LargeIntegerDivide(ExtendedIntegerMultiply(LargeIntegerSubtract(nCurCount, m_nInitCount),1000), m_nCountsPerSec, &nRemainder);
//        return nResCount.LowPart;  // vrati cas v milisekundach od zinicializovania
    }
};
/*
enum EGameCommandType {
    CT__NONE = 0,
    CT__DASH,
    CT__TURN,
    CT__KICK,
    CT__NECK,
    CT__MOVE,
    CT__CATCH
};

class CGameCommand
{
public:
    CGameCommand(EGameCommandType tCmdType = CT__NONE) { m_tCmdType = tCmdType; };

    CGameTime m_tGameTime;

    EGameCommandType m_tCmdType;
    double m_val_A,m_val_B;
};

class CGameCommandSeq
{
    CGameCommand m_cGameCommand;

public:
    void Add(CGameCommand *pGameCommand) { m_cGameCommand = *pGameCommand; };
    // FIXME: get iterator + next...
    CGameCommand *GetFirst() { return &m_cGameCommand; };
    CGameCommand *GetNext() { return NULL; }
};
*/
enum EEventType  {
    ET__NONE = 0,
    ET__RECEIVED_MSG,
    ET__START_DELIBERATION,
    ET__SEND_COMMANDS
};

class CEvent {
public:
    EEventType m_eType;

public:
    CEvent(EEventType eType = ET__NONE) { m_eType = eType; };
};

class CStartDeliberationEvent : public CEvent {
public:
    CPerceptionSeq *m_pPerceptionSeq;
    CGameCommandSeq *m_pGameCommandSeq;

    CStartDeliberationEvent() : CEvent(ET__START_DELIBERATION) {};
};

class CSendDataEvent : public CEvent {
public:
    CGameCommandSeq *m_pGameCommandSeq;

    CSendDataEvent() : CEvent(ET__SEND_COMMANDS) {};
};


extern FILE *m_ff;
//extern CTextMessageBuffer foo;

class CChildView;
class CChildTextView;

extern CChildView *m_pReadyView;
extern CChildTextView* m_pTextReadyView;

#endif  // TODOCLASSES_H
