// VisPerception.cpp: implementation of the CVisPerception class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Player.h"
#include "VisPerception.h"
#include "WorldObjects.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CVisPerception::CVisPerception()
{
	m_pAgent = new CAgent();						// aj toto, pekne sa tu nastavi smernik an skutocny objekt hraca
	m_pPerception = new CPerception();				// tak toto vo final nebude to je jasne
}

CVisPerception::~CVisPerception()
{
	delete m_pPerception;
	delete m_pAgent;
}

//////////////////////////////////////////////////////////////////////////////
// int CVisPerception::GetSeenFlag( int index, CVisObject* visObject )
// ---------------------------------------------------------------------------
// Description:
//		
//
// ---------------------------------------------------------------------------
// Parameters:
//		int index
//		CVisObject* visObject
//
//////////////////////////////////////////////////////////////////////////////
int CVisPerception::GetSeenFlag( int index, CVisObject* visObject )
{
	CSeenFlag	flag;
	int			retVal = m_pPerception->GetNextFlag( &flag, index );

	if ( retVal == -1 )
		return retVal;

	visObject->CreateFlag( &flag, m_pAgent );
	return retVal;
}

//////////////////////////////////////////////////////////////////////////////
// int CVisPerception::GetSeenPlayer( int index, CVisObject* visObject )
// ---------------------------------------------------------------------------
// Description:
//		
//
// ---------------------------------------------------------------------------
// Parameters:
//		int index
//		CVisObject* visObject
//
//////////////////////////////////////////////////////////////////////////////
int CVisPerception::GetSeenPlayer( int index, CVisObject* visObject )
{
	CSeenPlayer	player;
	int			retVal = m_pPerception->GetNextPlayer( &player, index );

	if ( retVal == -1 )
		return retVal;

	// the same for teammate and opponent ???????

	visObject->CreatePlayer( &player, m_pAgent );
	return retVal;
}

//////////////////////////////////////////////////////////////////////////////
// int CVisPerception::GetSeenBall( CVisObject* visObject )
// ---------------------------------------------------------------------------
// Description:
//		
//
// ---------------------------------------------------------------------------
// Parameters:
//		CVisObject* visObject
//
//////////////////////////////////////////////////////////////////////////////
int CVisPerception::GetSeenBall( CVisObject* visObject )
{
	CSeenObject	object;
	bool		pRetVal = m_pPerception->GetBall( &object );

	if ( !pRetVal )
		return -1;

	visObject->CreateBall( &object, m_pAgent );
	return 1;
}